/*******************************************************************************
 * Copyright 2020 Graz University of Technology
 * MOA ZS has been developed in a cooperation between EGIZ
 * and Graz University of Technology.
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
package at.gv.egiz.moazs.util;

import org.springframework.stereotype.Component;

import java.io.File;

/**
 * @author Christof Rabensteiner
 *
 */
@Component
public class FileUtils {

    /**
     * If path is relative, try to resolve path as classpath resource. If path is absolute,
     * leave as-is.
     */
    public String determinePath(String abstractPath) {
        if (new File(abstractPath).isAbsolute()) {
            return abstractPath;
        } else {
            //java.lang.Class needs relative resources to start with "/"
            var resource = this.getClass().getResource("/" + abstractPath);
            return resource == null ? abstractPath : resource.getFile();
        }
    }
}
